indexing
	description: 
		"Gemeinsame Schnittstelle im Entwurfsmuster Kompositum"
		"Die Klasse ist abstrakt, von ihr werden die Klasse Kompositum und die Klassen fr"
		"spezielle Graphiken abgeleitet"

class Graphik

inherit
	WEL_STANDARD_COLORS

feature {Graphik}
	Xgespiegelt,
	Ygespiegelt: BOOLEAN

	Ungueltig: INTEGER is -1

	Initialisiere is
		do
			Xlo := Ungueltig
			Ylo := Ungueltig
			Xru := Ungueltig
			Yru := Ungueltig
			Xgespiegelt := False
			Ygespiegelt := False
		end

feature {Graphik,BasisGraphik}
	Xlo, Ylo, Xru, Yru: REAL

	Name: STRING

	SetzeKoordinaten(X1, Y1, X2, Y2: REAL) is
		-- stellt Sicher, da Xlo <= Xru und Ylo <= Yru ist
		-- setzt die Koordinaten gegebenenfalls gespiegelt
		do
			if (X1 <= X2) then
				Xlo := X1
				Xru := X2
			else
				Xlo := X2
				Xru := X1
				Xgespiegelt := not(Xgespiegelt)
			end;
			if (Y1 <= Y2) then
				Ylo := Y1
				Yru := Y2
			else
				Ylo := Y2
				Yru := Y1
				Ygespiegelt := not(Ygespiegelt)
			end
		end

	ZeichneDich(Hervorgehoben,Markiert: BOOLEAN; dc: WEL_CLIENT_DC)  is 
		-- Einzige Gemeinsamkeit:
		-- Ist die Graphik markiert, so wird ein gaues gestricheltes Rechteck darum gezeichnet
		local
			X1,Y1,X2,Y2: INTEGER
			pen: WEL_PEN
		do
			if Markiert then
				X1 := Xlo.rounded
				X2 := Xru.rounded
				Y1 := Ylo.rounded
				Y2 := Yru.rounded
				!! pen.make (1,1,grey)
				dc.select_pen(pen)
				dc.line (X1,Y1,X2,Y1)
				dc.line (X2,Y1,X2,Y2)
				dc.line (X2,Y2,X1,Y2)
				dc.line (X1,Y2,X1,Y1)
				pen.delete
			end
		end

invariant
	Xlo <= Xru
	Ylo <= Yru
end