indexing
	description: 
		"Sammlung von Objekten der Klasse BasisGraphik"
		"Leitet Botschaften vom Hauptfenster (Klasse MAIN_WINDOW) an die markierten"
		"BasisGraphiken weiter"

class GraphikContainer

creation
	make

feature {NONE} -- Initialisierung und Hilfsfunktionen

	Graphiken: LINKED_LIST[BasisGraphik]
	HauptFenster: MAIN_WINDOW

	make(Fenster: MAIN_WINDOW) is
		do
			HauptFenster:= Fenster
			!!Graphiken.make
			NamensZaehler:= 0		-- zur autom. Generierung eindeutiger Namen
			ErwarteClickNr:= 0		-- zur berwachung der Koordinateneingabe
		end;

	NamensZaehler: INTEGER

	BasisGraphikHinzufuegen(eineGraphik: Graphik) is
		local
			Index: INTEGER;
			eineBasisGraphik: BasisGraphik
		do
			Index:= Graphiken.Index
			NamensZaehler:= NamensZaehler + 1
			!!eineBasisGraphik.make(eineGraphik, NamensZaehler)
			Graphiken.extend(eineBasisGraphik)
			Graphiken.go_i_th (Index)
			HauptFenster.Liste.add_string(eineBasisGraphik.Name)
		end;

	BasisGraphikManuellHinzufuegen(eineGraphik: Graphik) is
		-- wie BasisGraphikHinzufuegen,
		-- aber mit anschlieender manueller Koordinateneingabe
		do
			BasisGraphikHinzufuegen(eineGraphik)
			HauptFenster.Liste.unselect_all
			HauptFenster.Liste.select_item (HauptFenster.Liste.count - 1)
			MarkierungenAbgleichen
			SetzeKoordinaten(0,0)
		end

	BasisGraphikEntfernen is
		-- entfernt die BasisGraphik auf die der Zeiger in der Graphiken-Liste zeigt
		-- setzt den Zeiger eine BasisGraphik weiter
		do
			HauptFenster.Liste.delete_string(HauptFenster.Liste.find_string(0, Graphiken.item.Name))
			Graphiken.remove
		end;

	FindeBasisGraphik(einName: STRING): BOOLEAN is
		-- setzt den Zeiger der Graphiken-Liste auf die zu suchende BasisGraphik,
		-- falls sie auffindbar ist
		do
			from
				result:= false
				Graphiken.start
			until
				(Graphiken.after or result)
			loop
				result:= (Graphiken.item.Name.is_equal (einName))
				if not(result) then
					Graphiken.forth
				end
			end
		end

	FindeErsteMarkierte: BasisGraphik is
		-- gibt die erste markierte BasisGraphik in der der Graphiken-Liste zurck
		local
			Gefunden: BOOLEAN
		do
			from
			Gefunden:= false;
				Graphiken.start;
			until
				(Graphiken.after or Gefunden)
			loop
				if Graphiken.item.Markiert then
					Gefunden:= true
				else
					Graphiken.forth
				end;					
			end;
			if Gefunden then 
				result:= Graphiken.item
			end
		end

	AnzahlMarkierte: INTEGER is
		-- gibt die Anzahl der markierten BasisGraphiken in der der Graphiken-Liste zurck
		do
			from
				result:= 0
				Graphiken.start
			until
				Graphiken.after
			loop
				if Graphiken.item.Markiert then
					result:= result +1
				end;
				Graphiken.forth
			end;
		end	

	SetzeLO(X,Y: INTEGER) is
		do
			Xlo:= X
			Ylo:= Y
		end

feature {MAIN_WINDOW}

	Xlo,Ylo,Xru,Yru: INTEGER

	SetzeRU(X,Y: INTEGER) is
		do
			Xru:= X
			Yru:= Y
		end

	ErwarteClickNr: INTEGER

	SetzeKoordinaten(X,Y: INTEGER) is
		-- 1. Durchlauf: X,Y nicht wichtig, Erwartet jetzt 1. Mouse-Click
		-- 2. Durchlauf: Legt linkes oberes Koordinatepaar fest, Erwartet jetzt 2. Mouse-Click
		-- 3. Durchlauf: Setzt Koordinaten der BasisGraphik neu, beendet Koordinateneingabe
		local
			dieBasisGraphik: BasisGraphik
		do
			if (ErwarteClickNr = 0) then
				if (AnzahlMarkierte = 1) then
					ErwarteClickNr:= 1
				end
			elseif (ErwarteClickNr = 1) then
				SetzeLO(X,Y)
				SetzeRU(X,Y)
				ErwarteClickNr:= 2
			elseif (ErwarteClickNr = 2) then
				dieBasisGraphik:= FindeErsteMarkierte
				dieBasisGraphik.SetzeKoordinaten(Xlo,Ylo,X,Y)
				ErwarteClickNr:= 0
			end
		end

	AlleZeichnen(dc: WEL_CLIENT_DC) is
		do
			from
				Graphiken.start
			until
				Graphiken.after
			loop
				Graphiken.item.ZeichneDich(dc)
				Graphiken.forth
			end;
		end;

	MarkierungenAbgleichen is
		-- gleich die Markierungen der Graphiken-Liste
		-- auf die der MULTIPLE_SELECTION_LIST_BOX im Hauptfenster ab
		local
			i: INTEGER
		do
			from
				Graphiken.start
			until
				Graphiken.after
			loop
				Graphiken.item.SetzeMarkiert(false)
				Graphiken.forth
			end;
			from
				i:= 0
			until
				(i > HauptFenster.Liste.selected_strings.upper)
			loop
				if FindeBasisGraphik(HauptFenster.Liste.selected_strings.item(i)) then
					Graphiken.item.SetzeMarkiert(true)
				end
				i:= i+1
			end;
		end;

	MarkierteHervorheben is
		do		
			from
				Graphiken.start
			until
				Graphiken.after
			loop
				Graphiken.item.SetzeHervorgehoben(Graphiken.item.Markiert)
				Graphiken.forth
			end
		end


	MarkierteGruppieren is
		local
			einKompositum: Kompositum
			eineBasisGraphik: BasisGraphik
		do
			if AnzahlMarkierte > 1 then
				!!einKompositum.make
				from
					Graphiken.start
				until
					Graphiken.after
				loop
					if Graphiken.item.Markiert then
						einKompositum.FuegeHinzu(Graphiken.item.dieGraphik)
						BasisGraphikEntfernen
					else
						Graphiken.forth
					end
				end;
				BasisGraphikHinzufuegen(einKompositum) 
			end
		end

	MarkierteDegruppieren is
		local
			einKompositum: Kompositum
		do
			from
				Graphiken.start
			until
				Graphiken.after
			loop
				if Graphiken.item.Markiert then
					einKompositum ?= Graphiken.item.dieGraphik
					if einKompositum /= void then
						from
						until
							einKompositum.Kinder.after
						loop
							BasisGraphikHinzufuegen(einKompositum.EntferneErstesKind)
						end
						BasisGraphikEntfernen
					else
						Graphiken.forth	
					end
				else
					Graphiken.forth
				end
			end
		end

	MarkierteEntfernen is
		do
			from
				Graphiken.start
			until
				Graphiken.after
			loop
				if Graphiken.item.Markiert then
					BasisGraphikEntfernen
				else
					Graphiken.forth
				end
			end
		end

	NeueLinie is
		local
			eineLinie: Linie
		do
			!!eineLinie.make
			BasisGraphikManuellHinzufuegen(eineLinie)
		end

	NeueEllipse is
		local
			eineEllipse: Ellipse
		do
			!!eineEllipse.make
			BasisGraphikManuellHinzufuegen(eineEllipse)
		end

end
